package com.minemaarten.signals.client;

import java.util.ArrayList;
import java.util.List;

import net.minecraft.client.renderer.BufferBuilder;
import net.minecraft.util.math.Vec3d;

public class BakedRenderer{
    private double[] bakedPositions; //Double array for cache locality

    private List<Vec3d> verteces = new ArrayList<Vec3d>();

    public void render(BufferBuilder buffer){
        if(bakedPositions == null) {
            bakedPositions = new double[verteces.size() * 3];
            for(int i = 0; i < verteces.size(); i++) {
                Vec3d vertex = verteces.get(i);
                int startIndex = i * 3;
                bakedPositions[startIndex + 0] = vertex.field_72450_a;
                bakedPositions[startIndex + 1] = vertex.field_72448_b;
                bakedPositions[startIndex + 2] = vertex.field_72449_c;
            }
        }

        for(int i = 0; i < bakedPositions.length; i += 3) {
            buffer.func_181662_b(bakedPositions[i], bakedPositions[i + 1], bakedPositions[i + 2]).func_181675_d();
        }
    }

    public void add(double x, double y, double z){
        verteces.add(new Vec3d(x, y, z));
        bakedPositions = null;
    }
}
