package com.minemaarten.signals.client.gui;

import java.awt.Point;

import com.minemaarten.signals.client.gui.widget.IGuiWidget;
import com.minemaarten.signals.client.gui.widget.WidgetComboBox;
import com.minemaarten.signals.inventory.ContainerBase;
import com.minemaarten.signals.network.NetworkHandler;
import com.minemaarten.signals.network.PacketUpdateTextfield;
import com.minemaarten.signals.rail.network.mc.RailNetworkManager;
import com.minemaarten.signals.tileentity.TileEntityStationMarker;

public class GuiStationMarker extends GuiContainerBase<TileEntityStationMarker>{

    private WidgetComboBox stationNameField;

    public GuiStationMarker(TileEntityStationMarker te){
        super(new ContainerBase<>(te), te, null);
    }

    @Override
    public void func_73866_w_(){
        super.func_73866_w_();
        stationNameField = new WidgetComboBox(field_146289_q, field_146294_l / 2 - 50, field_146295_m / 2 - 5, 100, field_146289_q.field_78288_b);
        stationNameField.setElements(RailNetworkManager.getClientInstance().getNetwork().getStationNames());
        addWidget(stationNameField);
    }

    @Override
    protected boolean shouldDrawBackground(){
        return false;
    }

    @Override
    protected Point getInvTextOffset(){
        return null;
    }

    @Override
    public void func_73876_c(){
        super.func_73876_c();
        if(!stationNameField.func_146206_l()) {
            stationNameField.func_146180_a(te.getStationName());
        }
    }

    @Override
    public void onKeyTyped(IGuiWidget widget){
        super.onKeyTyped(widget);
        te.setText(0, stationNameField.func_146179_b());
        NetworkHandler.sendToServer(new PacketUpdateTextfield(te, 0));
    }
}
