package com.minemaarten.signals.client.gui.widget;

import java.awt.Rectangle;
import java.util.ArrayList;
import java.util.List;

import net.minecraft.client.gui.FontRenderer;
import net.minecraft.client.gui.GuiTextField;

import org.apache.commons.lang3.StringUtils;

public class WidgetTextField extends GuiTextField implements IGuiWidget{

    protected IWidgetListener listener;
    private final List<String> tooltip = new ArrayList<>();
    private boolean passwordBox;

    public WidgetTextField(FontRenderer fontRenderer, int x, int y, int width, int height){
        super(-1, fontRenderer, x, y, width, height);
    }

    @Override
    public void setListener(IWidgetListener gui){
        listener = gui;
    }

    public WidgetTextField setAsPasswordBox(){
        passwordBox = true;
        return this;
    }

    @Override
    public int getID(){
        return -1;
    }

    @Override
    public void render(int mouseX, int mouseY, float partialTick){
        String oldText = func_146179_b();
        int oldCursorPos = func_146198_h();
        if(passwordBox) {
            func_146180_a(StringUtils.repeat('*', oldText.length()));
            func_146190_e(oldCursorPos);
        }
        func_146194_f();
        if(passwordBox) {
            func_146180_a(oldText);
            func_146190_e(oldCursorPos);
        }
    }

    @Override
    public void onMouseClicked(int mouseX, int mouseY, int button){
        func_146192_a(mouseX, mouseY, button);
        if(func_146206_l() && button == 1) {
            func_146180_a("");
            listener.onKeyTyped(this);
        }
    }

    @Override
    public void onMouseClickedOutsideBounds(int mouseX, int mouseY, int button){
        onMouseClicked(mouseX, mouseY, button);
    }

    @Override
    public Rectangle getBounds(){
        return new Rectangle(field_146209_f, field_146210_g, field_146218_h, field_146219_i);
    }

    @Override
    public void addTooltip(int mouseX, int mouseY, List<String> curTooltip, boolean shiftPressed){
        curTooltip.addAll(tooltip);
    }

    public void setTooltip(String... tooltip){
        this.tooltip.clear();
        for(String s : tooltip)
            this.tooltip.add(s);
    }

    @Override
    public boolean onKey(char key, int keyCode){
        if(func_146201_a(key, keyCode)) {
            listener.onKeyTyped(this);
            return true;
        }
        return false;
    }

    @Override
    public void update(){

    }

    @Override
    public void handleMouseInput(){

    }

    @Override
    public void postRender(int mouseX, int mouseY, float partialTick){}

}
